var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Bridge } from "../bridge/bridge.js";
import { parseBigNumberish } from "./helpers.js";
import { useSignerFromEthereumFn } from "./signer.js";
import { useApproveStatus, useCheckAllowance } from "./tokens.js";
import { useEffect, useState } from "react";
function useCalculateBridgeSwapOutput(ethereum, chainId) {
    var _a = useState(null), result = _a[0], setResult = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var fnArgs, synapseBridge, res, e_1, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fnArgs = __assign(__assign({}, args), { amountFrom: parseBigNumberish(args.amountFrom, args.tokenFrom, chainId) });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        synapseBridge = new Bridge.SynapseBridge({ network: chainId });
                        return [4 /*yield*/, synapseBridge.estimateBridgeTokenOutput(fnArgs)];
                    case 2:
                        res = _a.sent();
                        setResult(res);
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        err = e_1 instanceof Error ? e_1 : new Error(e_1);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, result];
}
function useExecuteBridgeSwap(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    var _a = useState(null), tx = _a[0], setTx = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var fnArgs, synapseBridge, res, e_2, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fnArgs = __assign(__assign({}, args), { amountFrom: parseBigNumberish(args.amountFrom, args.tokenFrom, chainId), amountTo: parseBigNumberish(args.amountTo, args.tokenTo, args.chainIdTo) });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        synapseBridge = new Bridge.SynapseBridge({ network: chainId });
                        return [4 /*yield*/, synapseBridge.executeBridgeTokenTransaction(fnArgs, getSigner(ethereum))];
                    case 2:
                        res = _a.sent();
                        setTx(res);
                        return [3 /*break*/, 4];
                    case 3:
                        e_2 = _a.sent();
                        err = e_2 instanceof Error ? e_2 : new Error(e_2);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, tx];
}
function useApproveBridgeSwap(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    var _a = useApproveStatus(ethereum, chainId), queryApproveStatus = _a[0], approvelStatus = _a[1];
    var _b = useState(null), approveTx = _b[0], setApproveTx = _b[1], _c = useState(null), approveData = _c[0], setApproveData = _c[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var amt, fnArgs, synapseBridge, spender, res, e_3, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        amt = args.amount
                            ? parseBigNumberish(args.amount, args.token, chainId)
                            : undefined;
                        fnArgs = __assign(__assign({}, args), { amount: amt });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        synapseBridge = new Bridge.SynapseBridge({ network: chainId });
                        spender = synapseBridge.buildERC20ApproveArgs(fnArgs)[0].spender;
                        return [4 /*yield*/, synapseBridge.executeApproveTransaction(fnArgs, getSigner(ethereum))];
                    case 2:
                        res = _a.sent();
                        setApproveTx(res);
                        setApproveData(__assign(__assign({}, fnArgs), { spender: spender }));
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _a.sent();
                        err = e_3 instanceof Error ? e_3 : new Error(e_3);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    useEffect(function () {
        if (approveTx && approveData && !approvelStatus) {
            var token = approveData.token, spender = approveData.spender, amount = approveData.amount;
            queryApproveStatus({
                token: token,
                spender: spender,
                amount: amount,
                approveTx: approveTx
            });
        }
    }, [approveTx, approveData, approvelStatus]);
    return [fn, approveTx, approvelStatus];
}
function useBridgeAllowance(ethereum, chainId) {
    var _a = useCheckAllowance(ethereum, chainId), checkAllowance = _a[0], allowance = _a[1];
    function fn(token) {
        return __awaiter(this, void 0, void 0, function () {
            var synapseBridge, spender, e_4, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        synapseBridge = new Bridge.SynapseBridge({ network: chainId });
                        spender = synapseBridge.buildERC20ApproveArgs({ token: token })[0].spender;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, checkAllowance({ token: token, spender: spender })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_4 = _a.sent();
                        err = e_4 instanceof Error ? e_4 : new Error(e_4);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, allowance];
}
export { useApproveBridgeSwap, useExecuteBridgeSwap, useCalculateBridgeSwapOutput, useBridgeAllowance };
