var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { Tokens } from "../tokens.js";
import { ERC20, MAX_APPROVAL_AMOUNT } from "../bridge/erc20.js";
import { parseApproveAmount } from "./helpers.js";
import { useSignerFromEthereumFn } from "./signer.js";
import { useEffect, useState } from "react";
var TX_STATUS_REVERTED = 0, TX_STATUS_SUCCESS = 1;
var TransactionError = /** @class */ (function (_super) {
    __extends(TransactionError, _super);
    function TransactionError(txHash, message, cause) {
        var _this = _super.call(this, message) || this;
        _this.name = _this.constructor.name;
        _this.message = "Error in transaction ".concat(txHash, ": ").concat(message);
        if (cause) {
            _this.cause = cause;
        }
        return _this;
    }
    return TransactionError;
}(Error));
var AllowanceError = /** @class */ (function (_super) {
    __extends(AllowanceError, _super);
    function AllowanceError(owner, spender, token, message, cause) {
        var _this = _super.call(this, message) || this;
        _this.name = _this.constructor.name;
        _this.message = "Error querying spend allowance of ".concat(spender, " for ").concat(owner, " token ").concat(token.name);
        if (cause) {
            _this.cause = cause;
        }
        return _this;
    }
    return AllowanceError;
}(Error));
function useCheckAllowance(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    var _a = useState(null), allowance = _a[0], setAllowance = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var signer, ownerAddress, token, spender, allowanceRes, e_1, err, allowanceErr;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        signer = getSigner(ethereum);
                        return [4 /*yield*/, signer.getAddress()];
                    case 1:
                        ownerAddress = _a.sent();
                        token = args.token, spender = args.spender;
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, ERC20.allowanceOf(ownerAddress, spender, { tokenAddress: token.address(chainId), chainId: chainId })];
                    case 3:
                        allowanceRes = _a.sent();
                        setAllowance(allowanceRes);
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _a.sent();
                        err = e_1 instanceof Error ? e_1 : new Error(e_1);
                        allowanceErr = new AllowanceError(ownerAddress, spender, token, "exception thrown from ERC20.allowanceOf()", err);
                        console.error(allowanceErr);
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, allowance];
}
function useApproveTokenSpend(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    var _a = useState(null), tx = _a[0], setTx = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var res, e_2, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, Tokens.approveTokenSpend(__assign(__assign({}, args), { amount: parseApproveAmount(args.amount, args.token, chainId), chainId: chainId, signer: getSigner(ethereum) }))];
                    case 1:
                        res = _a.sent();
                        setTx(res);
                        return [3 /*break*/, 3];
                    case 2:
                        e_2 = _a.sent();
                        err = e_2 instanceof Error ? e_2 : new Error(e_2);
                        console.error(err);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, tx];
}
function useApproveStatus(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    var _a = useCheckAllowance(ethereum, chainId), checkAllowance = _a[0], allowance = _a[1];
    var _b = useState(false), approveComplete = _b[0], setApproveComplete = _b[1];
    var _c = useState(null), wantApproveAmount = _c[0], setWantApproveAmount = _c[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var token, spender, amount, approveTx, signer, txHash, wantAmt, ownerAddress, txResult, txErr, e_3, err, txErr, e_4, err, allowanceErr;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        token = args.token, spender = args.spender, amount = args.amount, approveTx = args.approveTx;
                        signer = getSigner(ethereum);
                        txHash = approveTx.hash;
                        wantAmt = amount ? parseApproveAmount(amount, token, chainId) : MAX_APPROVAL_AMOUNT;
                        return [4 /*yield*/, signer.getAddress()];
                    case 1:
                        ownerAddress = _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, approveTx.wait(1)];
                    case 3:
                        txResult = _a.sent();
                        if (txResult.status !== TX_STATUS_SUCCESS) {
                            txErr = new TransactionError(txHash, "reverted");
                            console.error(txErr);
                            return [2 /*return*/];
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        e_3 = _a.sent();
                        err = e_3 instanceof Error ? e_3 : new Error(e_3);
                        txErr = new TransactionError(txHash, "exception thrown from .wait(1)", err);
                        console.error(txErr);
                        return [3 /*break*/, 5];
                    case 5:
                        _a.trys.push([5, 7, , 8]);
                        return [4 /*yield*/, checkAllowance({ spender: spender, token: token })];
                    case 6:
                        _a.sent();
                        setWantApproveAmount(wantAmt);
                        return [3 /*break*/, 8];
                    case 7:
                        e_4 = _a.sent();
                        err = e_4 instanceof Error ? e_4 : new Error(e_4);
                        allowanceErr = new AllowanceError(ownerAddress, spender, token, "exception thrown from ERC20.allowanceOf()", err);
                        console.error(allowanceErr);
                        return [3 /*break*/, 8];
                    case 8: return [2 /*return*/];
                }
            });
        });
    }
    useEffect(function () {
        if (allowance && wantApproveAmount) {
            var checkAmt = wantApproveAmount;
            if (wantApproveAmount.eq(MAX_APPROVAL_AMOUNT)) {
                checkAmt = MAX_APPROVAL_AMOUNT.sub(5);
            }
            if (allowance.gte(checkAmt)) {
                setApproveComplete(true);
            }
        }
    }, [allowance, wantApproveAmount]);
    return [fn, approveComplete, allowance];
}
export { TransactionError, AllowanceError, useApproveTokenSpend, useApproveStatus, useCheckAllowance };
